@q This file defines syntax keywords and type names introduced in @>
@q modern dialects of C and C++ as special entities for formatting @>

@q C99 and C11 keywords, see http://en.cppreference.com/w/c/keyword @>

@s restrict int

@q C99 and C11 types @>

@s _Alignas int
@s _Alignof int
@s _Atomic int
@s _Bool int
@s _Complex int
@s _Generic int
@s _Imaginary int
@s _Noreturn int
@s _Static_assert int
@s _Thread_local int

@s alignas int
@s alignof int
@s atomic_bool int
@s atomic_char int
@s atomic_schar int
@s atomic_uchar int
@s atomic_short int
@s atomic_ushort int
@s atomic_int int
@s atomic_uint int
@s atomic_long int
@s atomic_ulong int
@s atomic_llong int
@s atomic_ullong int
@s atomic_char16_t int
@s atomic_char32_t int
@s atomic_wchar_t int
@s atomic_int_least8_t int
@s atomic_uint_least8_t int
@s atomic_int_least16_t int
@s atomic_uint_least16_t int
@s atomic_int_least32_t int
@s atomic_uint_least32_t int
@s atomic_int_least64_t int
@s atomic_uint_least64_t int
@s atomic_int_fast8_t int
@s atomic_uint_fast8_t int
@s atomic_int_fast16_t int
@s atomic_uint_fast16_t int
@s atomic_int_fast32_t int
@s atomic_uint_fast32_t int
@s atomic_int_fast64_t int
@s atomic_uint_fast64_t int
@s atomic_intptr_t int
@s atomic_uintptr_t int
@s atomic_size_t int
@s atomic_ptrdiff_t int
@s atomic_intmax_t int
@s atomic_uintmax_t int
@s bool int
@s complex int
@s imaginary int
@s noreturn int
@s static_assert int
@s thread_local int

@q C99 preprocessor @>

@s _Pragma int

@q C++99 and C++11 keywords, see http://en.cppreference.com/w/cpp/keyword @>

@s constexpr int
@s decltype int
@s false int
@s final int
@s noexcept int
@s override int
@s true int

@q Fundamental types of C++99 and C++11, see @>
@q http://en.cppreference.com/w/cpp/language/types @>

@s nullptr_t int
@s char16_t int
@s char32_t int

@q Integral types of C99 and C++, see @>
@q http://en.cppreference.com/w/c/types/integer and @>
@q http://en.cppreference.com/w/cpp/types/integer @>

@s int8_t int
@s int16_t int
@s int32_t int
@s int64_t int
@s int_fast8_t int
@s int_fast16_t int
@s int_fast32_t int
@s int_fast64_t int
@s int_least8_t int
@s int_least16_t int
@s int_least32_t int
@s int_least64_t int
@s intmax_t int
@s intptr_t int
@s uint8_t int
@s uint16_t int
@s uint32_t int
@s uint64_t int
@s uint_fast8_t int
@s uint_fast16_t int
@s uint_fast32_t int
@s uint_fast64_t int
@s uint_least8_t int
@s uint_least16_t int
@s uint_least32_t int
@s uint_least64_t int
@s uintmax_t int
@s uintptr_t int
